//#define usingZip
using System;
using Server;
using System.IO; 
using System.Text; 
using System.Reflection; 
using System.Collections; 
using Server.Items;
using Server.Targeting;
using Server.Mobiles;
using Server.SkillHandlers;
using System.Threading;
#if usingZip
using ICSharpCode.SharpZipLib.Zip;
using ICSharpCode.SharpZipLib.Checksums;
using ICSharpCode.SharpZipLib.GZip;
#endif
//Script Version 1.1026

namespace Server.Scripts.Commands
{
	public class GMToolsTravel
	{
		public static void Initialize()
		{
			Server.Commands.Register( "GMTGo", AccessLevel.GameMaster, new CommandEventHandler( gmtgo_OnCommand ) );
			Server.Commands.Register( "GMTSGo", AccessLevel.GameMaster, new CommandEventHandler( gmtsgo_OnCommand ) );
		}
		[Usage( "GMTGo <x> <y> <z> <m>" )]
		[Description( "Sets the location and map of the targeted mobile." )]
		public static void gmtgo_OnCommand( CommandEventArgs arg )
		{
			if ( arg.Length != 4 )
			{
				arg.Mobile.SendMessage( "GMTGo <x> <y> <z> <m>" );
			}
			else
			{
				arg.Mobile.Target = new GMTTravelTarget( arg.GetInt32(0),arg.GetInt32(1),arg.GetInt32(2),arg.GetInt32(3) );
			}
		}
		
		[Usage( "GMTSGo <x> <y> <z> <m>" )]
		[Description( "Sets your location and map." )]
		public static void gmtsgo_OnCommand( CommandEventArgs arg )
		{
			if ( arg.Length != 4 )
			{
				arg.Mobile.SendMessage( "GMTSGo <x> <y> <z> <m>" );
			}
			else
			{
				string temp;
				int m_x=arg.GetInt32(0);
				int m_y=arg.GetInt32(1);
				int m_z=arg.GetInt32(2);
				int m_m=arg.GetInt32(3);
				arg.Mobile.Location = new Point3D(  m_x, m_y, m_z );
				temp=Server.Scripts.Commands.Properties.SetValue(arg.Mobile,arg.Mobile,"map",m_m.ToString());
				CommandLogging.WriteLine(arg.Mobile, "Moved " + arg.Mobile.Name + " to " + m_x + "," + m_y + "," + m_z + ":Map" + m_m );
			}
		}
	}
	public class GMTTravelTarget : Target
	{
		private int m_x;
		private int m_y;
		private int m_z;
		private int m_m;
		public GMTTravelTarget( int x, int y, int z, int m ) : base( -1, false, TargetFlags.None )
		{
			m_x=x;
			m_y=y;
			m_z=z;
			m_m=m;
		}
		protected override void OnTarget( Mobile from, object targeted )
		{
			if ( targeted is Mobile )
			{
				Mobile targ = (Mobile)targeted;
				string temp;
				targ.Location = new Point3D(  m_x, m_y, m_z );
				temp=Server.Scripts.Commands.Properties.SetValue(from,targ,"map",m_m.ToString());
				CommandLogging.WriteLine(from, "Moved " + targ.Name + " to " + m_x + "," + m_y + "," + m_z + ":Map" + m_m );
			}
			else
			{
				from.SendMessage( "Sorry, you can not move that!" );
			}
		}
	}


	/// <summary>
	/// Summary description for setmap.
	/// </summary>
	public class GMToolsSupport
	{
		public static void Initialize()
		{
			Server.Commands.Register( "selfadd", AccessLevel.Counselor , new CommandEventHandler( gmtools_self_add ) );
			Server.Commands.Register( "where", AccessLevel.Counselor , new CommandEventHandler( gmtools_where ) );
		}
		[Usage( "where" )]
		[Description( "shows your xyz coords" )]
		public static void gmtools_where( CommandEventArgs e )
		{ 
			e.Mobile.SendMessage(string.Format("You are at {0},{1},{2} on {3}",e.Mobile.X, e.Mobile.Y, e.Mobile.Z,e.Mobile.Map));
		}
		public static void gmtools_self_add( CommandEventArgs e )
		{
			if (e.Arguments.GetLength(0)==2)
			{
				//e.Mobile.SendMessage(Server.Scripts.Commands.Properties.SetValue(e.Mobile,e.Mobile,e.Arguments[0].Trim(),e.Arguments[1].Trim()));
				//IPoint3D p =  e.Mobile.Location;
				Server.Scripts.Commands.Add.Invoke( e.Mobile, new Point3D( e.Mobile.Location ), new Point3D( e.Mobile.Location ), e.Arguments );
			}
			else
			{
				e.Mobile.SendMessage(@"Usage:selfadd [<name> <value>]");
			}
		}
	}

}


namespace Server.Scripts.ToolData 
{ 
	public class TDCommand 
	{ 
		public static void Initialize() 
		{ 
			Server.Commands.Register( "tooldata", AccessLevel.Administrator, new CommandEventHandler( TD_OnCommand ) ); 
			Server.Commands.Register( "tooldataItem", AccessLevel.Administrator, new CommandEventHandler( BuildItems ) ); 
			Server.Commands.Register( "tooldataSpawn", AccessLevel.Administrator, new CommandEventHandler( BuildSpawns ) ); 
			Server.Commands.Register( "tooldataSetting", AccessLevel.Administrator, new CommandEventHandler( BuildSettings ) ); 
			Server.Commands.Register( "tooldataZip", AccessLevel.Administrator, new CommandEventHandler( buildZip_OnCommand ) ); 		
		} 

		public TDCommand() 
		{ 
		} 
		[Usage( "TooldataZip" )]
		[Description( "Builds all the GMTool data files and muls into a zip file" )]
		public static void buildZip_OnCommand( CommandEventArgs e ) 
		{ 
			if (gmtZipProcRunning) 
			{
				e.Mobile.SendMessage("GMT Zip process is currently running.  Try again later.");
				return;
			}
			bool tram=false;
			bool fel=false;
			bool isl=false;
			bool malas=false;
			string tVer="0";
			if (e.Arguments.Length>=1)
				tVer=e.Arguments[0];
			if (e.Arguments.Length>=2)
				try
				{
					tram=System.Convert.ToBoolean(e.Arguments[1]);
				}
				catch{}
			if (e.Arguments.Length>=3)
				try
				{
					fel=System.Convert.ToBoolean(e.Arguments[2]);
				}
				catch{}
			if (e.Arguments.Length>=4)
				try
				{
					isl=System.Convert.ToBoolean(e.Arguments[3]);
				}
				catch{}
			if (e.Arguments.Length>=5)
				try
				{
					malas=System.Convert.ToBoolean(e.Arguments[4]);
				}
				catch{}
			
			(new Thread(new ThreadStart((new GMTZipBuilder(tVer, tram, fel, isl, malas,e)).BuildZip))).Start();
		}
		public static bool gmtZipProcRunning=false;
		public class GMTZipBuilder
		{
			Mobile who;
			CommandEventArgs e;
			bool tram,  fel,  ils,  malas;
			string version;
			string servername;
			public GMTZipBuilder(bool ttram, bool tfel, bool tils, bool tmalas,CommandEventArgs ev):this("0", ttram, tfel, tils, tmalas, ev)
			{
			}
			public GMTZipBuilder(string tversion, bool ttram, bool tfel, bool tils, bool tmalas,CommandEventArgs ev)
			{
				if(tversion.Length>2)
					version=tversion;
				else
					version=tversion +".0";
				tram=ttram;
				fel=tfel;
				ils=tils;
				malas=tmalas;
				e=ev;
				who=e.Mobile;
				servername=Misc.ServerList.ServerName;
				servername.Replace('.','_');
				servername.Replace('*','_');
				servername.Replace('&','_');
				servername.Replace('?','_');
				gmtZipProcRunning=true;
			}
			public void BuildZip()
			{			
				who.SendMessage("Tram {0} included, Fel {1} included, ilshanr {2} included, mala {3} included", 
					tram ? "is" : "is not",
					fel ? "is" : "is not",
					ils ? "is" : "is not",
					malas ? "is" : "is not");
				BuildAll(e,servername);
				Directory.CreateDirectory(@servername + @"\Speech");
				Directory.CreateDirectory(@servername + @"\Spawns");
				Directory.CreateDirectory(@servername + @"\Locations");
				Directory.CreateDirectory(@servername + @"\Locations\custom");
				Directory.CreateDirectory(@servername + @"\Mul");
				System.IO.StreamWriter sr=new StreamWriter(@servername + @"\version.txt",false);
				sr.WriteLine(version);
				sr.Close();
				if (ils)
					this.copyFacet(2);	
				Console.WriteLine("zip wirte:{0}","ilsh done");
				if (malas)
					this.copyFacet(3);	
				Console.WriteLine("zip wirte:{0}","malas done");
				if ((tram)||(fel))
					this.copyFacet(0);	
				File.Copy(@"data\treasure.cfg",@servername + @"\treasure.cfg",true);
				Console.WriteLine("zip wirte:{0}","treasure done");
				File.Copy(@"data\regions.xml",@servername + @"\Locations\regions.xml",true);
				Console.WriteLine("zip wirte:{0}","regions done");
				File.Copy(@"data\Locations\felucca.xml",@servername + @"\Locations\felucca.xml",true);
				Console.WriteLine("zip wirte:{0}","fel xml done");
				File.Copy(@"data\Locations\ilshenar.xml",@servername + @"\Locations\ilshenar.xml",true);
				Console.WriteLine("zip wirte:{0}","ils.xml done");
				File.Copy(@"data\Locations\malas.xml",@servername + @"\Locations\malas.xml",true);
				Console.WriteLine("zip wirte:{0}","malas xml done");
				File.Copy(@"data\Locations\trammel.xml",@servername + @"\Locations\trammel.xml",true);
				Console.WriteLine("zip wirte:{0}","tram xml done");
#if usingZip
				who.SendMessage("Building the zip file, this may take several minutes");
				Crc32 crc = new Crc32();
				ZipOutputStream op = new ZipOutputStream(File.Create(@servername+".zip"));
				op.SetLevel(9);
				//ICSharpCode.SharpZipLib.Zip.ZipOutputStream op = new ZipOutputStream( (new StreamWriter(string.Format(@"{0}.zip",servername)) ).BaseStream);
				AddDirectoryToZip(op,crc,@servername);
				op.Finish();
				op.Close();
				who.SendMessage("GMT Zip file is ready");
#else
			who.SendMessage("Zip file support not installed, sorry");
#endif
				gmtZipProcRunning=false;
			}
			public void copyFacet(int i)
			{
				copyFile("map" + i + ".mul");
				copyFile("Staidx" + i + ".mul");
				copyFile("statics" + i + ".mul");

				Console.WriteLine("zip wirte:{0}",@"facet " + i + " done");
			}
			public void copyFile(string fName)
			{
				string tempDir=Core.FindDataFile(fName);
				Console.WriteLine("zip wirte:{0}",tempDir);
				if (File.Exists(@servername + @"\Mul\" + fName))
					if (File.GetLastWriteTime(@servername + @"\Mul\" + fName) < File.GetLastWriteTime(tempDir))
						File.Copy(tempDir,@servername + @"\Mul\" + fName,true);
			}
#if usingZip
			public static void AddDirectoryToZip(ICSharpCode.SharpZipLib.Zip.ZipOutputStream s, Crc32 crc,string dir)
			{
				System.IO.FileStream StreamToZip;
				foreach(string file in Directory.GetFiles(dir))
				{
					FileStream fs = File.OpenRead(file);
					byte[] buffer = new byte[fs.Length];
					fs.Read(buffer, 0, buffer.Length);
					ZipEntry entry = new ZipEntry(file);
			
					entry.DateTime = DateTime.Now;

					entry.Size = fs.Length;
					fs.Close();
			
					crc.Reset();
					crc.Update(buffer);
			
					entry.Crc  = crc.Value;
			
					s.PutNextEntry(entry);
			
					s.Write(buffer, 0, buffer.Length);
				}
				foreach(string k in Directory.GetDirectories(dir))
				{
					AddDirectoryToZip(s,crc,k);
				}
			}
#endif
		}
		[Usage( "Tooldata" )]
		[Description( "Builds all the GMTool data files." )]
		public static void TD_OnCommand( CommandEventArgs e ) 
		{ 
			BuildAll(e);
		}
		public static void BuildAll(CommandEventArgs e, string tPath)
		{
			BuildItems(e,tPath);
			BuildSpawns(e,tPath);
			BuildSettings(e,tPath);
		}
		public static void BuildAll(CommandEventArgs e)
		{
			BuildAll(e,"tooldata");
		}
		[Usage( "TooldataSetting" )]
		[Description( "Builds the GMTool settings.txt data file." )]
		public static void BuildSettings(CommandEventArgs e)
		{
			BuildSettings(e, "tooldata");
		}
		[Usage( "TooldataSetting" )]
		[Description( "Builds the GMTool settings.txt data file." )]
		public static void BuildSettings(CommandEventArgs e, string tPath)
		{
			if ( !Directory.Exists( @tPath ) ) 
				Directory.CreateDirectory( @tPath ); 
			Console.Write( "Scripts: Generating 3rd Party settings Database ..." ); 
			using ( StreamWriter op = new StreamWriter( @tPath + @"\Settings.txt" ) ) 
			{ 
				op.WriteLine( "// " ); 
				op.WriteLine( "// RunUO Generated Datafiles for 3rd Party Use." ); 
				op.WriteLine( "// See http://www.runuo.com/" ); 
				op.WriteLine( "// Settings version by Cat@salemx.net" ); 
				op.WriteLine( "// "); 
				op.WriteLine( "inputl=80");
				op.WriteLine( "tellcm=tell");
				op.WriteLine( "addtop=addtopack");
				op.WriteLine( "Betavr=36");
				op.WriteLine( "mtelec=multi tele");
				op.WriteLine( "prefix=" + Server.Commands.CommandPrefix.Trim());
				op.WriteLine( "gocmd =go");
				op.WriteLine( "addcmd=add");
				op.WriteLine( "selfad=selfadd");
				op.WriteLine( "remcmd=remove");
				op.WriteLine( "mremov=multi remove");
				
				op.WriteLine( "spawne=gmtspawner");
				op.WriteLine( "wipecm=wipe");
				op.WriteLine( "nonsta=item");
				op.WriteLine( "static=static");
				op.WriteLine( "tilecm=tile");
				op.WriteLine( "tilezc=tilez");
				op.WriteLine( "propsc=props");
				op.WriteLine( "nudgez=inc z");
				op.WriteLine( "wherec=where");
				op.WriteLine( "setcmd=set");
				op.WriteLine( "colorc=hue");
				op.WriteLine( "hidecm=self set hidden true");
				op.WriteLine( "unhide=self set hidden false");
				op.WriteLine( "chmapc=map");
				op.WriteLine( "clight=light");
				op.WriteLine( "msgsta=smsg");
				op.WriteLine( "msgall=bcast");

				op.WriteLine( "propMV=movable");
				op.WriteLine( "propLK=locked");
				op.WriteLine( "viscmd=vis");
				op.WriteLine( "globlt=globallight");
				op.WriteLine( "visclr=visclear");
				op.WriteLine( "flipcm=flip");
				op.WriteLine( "sendcm=gmtgo");
				op.WriteLine( "movecm=move");
				op.WriteLine( "telgen=telgen");
				op.WriteLine( "signge=signgen");
				op.WriteLine( "moonge=moongen");
				op.WriteLine( "doorge=doorgen");
				op.WriteLine( "vengen=vendorgen");
				op.WriteLine( "uoamge=uoamvendors");
				op.WriteLine( "docgen=docgen");
				op.WriteLine( "toolda=ToolData");
				op.WriteLine( "itMove=inc");
				op.WriteLine( "itGMov=area inc");
				op.WriteLine( "Recent=5");
				op.WriteLine( "myself=self set");
				op.WriteLine( "psound=privsound");
				op.WriteLine( "sound =sound");
				op.WriteLine( "get   =get");
				op.WriteLine( "staskl=setallskills");
				op.WriteLine( "setskl=setskill");

				
				foreach(string temp in Enum.GetNames(typeof(LightType))) op.WriteLine( "light =" + temp);
				op.WriteLine( "skills=skills");
				foreach(string temp in Enum.GetNames(typeof(SkillName))) op.WriteLine( "skill =" + temp);
				op.Close();
			}
			e.Mobile.SendMessage( "done" ); 
			Console.WriteLine( "done" ); 
		}
		
		[Usage( "TooldataSpawn" )]
		[Description( "Builds the GMTool spawn.txt data file." )]
		public static void BuildSpawns(CommandEventArgs e)
		{
			BuildSpawns( e,"tooldata");
		}
		[Usage( "TooldataSpawn" )]
		[Description( "Builds the GMTool spawn.txt data file." )]
		public static void BuildSpawns(CommandEventArgs e,string tPath)
		{
			int iCount = 0;
			if ( !Directory.Exists( @tPath ) ) 
				Directory.CreateDirectory( @tPath ); 

			Console.Write( "Scripts: Generating 3rd Party Spawn Database ..." ); 
			
			using ( StreamWriter op = new StreamWriter( @tPath + @"\Spawn.txt" ) ) 
			{ 
				op.WriteLine( "// " ); 
				op.WriteLine( "// RunUO Generated Datafiles for 3rd Party Use." ); 
				op.WriteLine( "// See http://www.runuo.com/" ); 
				op.WriteLine( "// Spawn version modified by Cat" ); 
				op.WriteLine( "// "); 
				for(int iTemp=0; iTemp<ScriptCompiler.Assemblies.Length; iTemp++)
				{
					foreach( Type t in ScriptCompiler.Assemblies[iTemp].GetTypes() )
					{	 
						//t = ScriptCompiler.Assemblies[iCount].GetType();
						//Type t=temp.GetType();
						Type[] ctorTypes = new Type[0]; 
						ConstructorInfo ctor = t.GetConstructor( ctorTypes ); 
						if ( ctor == null || t.IsAbstract ) continue; 
						if ( t.IsSubclassOf( typeof( Mobile ) ) ) 
						{ 
							Mobile i = (Mobile)ctor.Invoke( null ); 
							
							if ( i == null ) continue; 
							string ItemName = "None"; 
							string MainCat = "None"; 
							string SubCat = "None"; 
							ArrayList subTypes = new ArrayList(); 
							Type sub = t; 
							while ( sub.BaseType != typeof( object ) && sub.BaseType != null ) 
							{ 
								subTypes.Add( sub.BaseType.Name ); 
								sub = sub.BaseType; 
							} 

							if ( subTypes.Count >= 1 ) 
							{ 
								MainCat = subTypes[0] as string; 
							} 
                        
							if ( subTypes.Count >= 2 ) 
							{ 
								SubCat = subTypes[1] as string; 
							} 

							if ( i.Name == null ) 
							{ 
								ItemName="Unknown";
							} 
							else 
							{ 
								ItemName = i.Name; 
							} 
							op.WriteLine( t.Name + "=" + MainCat + ", " + SubCat + "=" + ItemName + "=" + i.Hue + "=" + i.BodyValue); 
							iCount++;
							i.Delete(); 
						} 
					}
				}
				op.Close();
			} 
			e.Mobile.SendMessage( "done [ " + iCount + " Spawns ]" ); 
			Console.WriteLine( "done [ " + iCount + " Spawns ]" ); 

		}
		
		[Usage( "TooldataItem" )]
		[Description( "Builds the GMTool item.txt data file." )]
		public static void BuildItems(CommandEventArgs e)
		{
			BuildItems(e, "tooldata");
		}
		[Usage( "TooldataItem" )]
		[Description( "Builds the GMTool item.txt data file." )]
		public static void BuildItems(CommandEventArgs e,string tPath)
		{
			int iCount = 0;
			if ( !Directory.Exists( @tPath ) ) 
				Directory.CreateDirectory( @tPath ); 

			Console.Write( "Scripts: Generating 3rd Party Item Database ..." ); 
			
			using ( StreamWriter op = new StreamWriter( @tPath + @"\items.txt" ) ) 
			{ 
				op.WriteLine( "// " ); 
				op.WriteLine( "// RunUO Generated Datafiles for 3rd Party Use." ); 
				op.WriteLine( "// See http://www.runuo.com/" ); 
				op.WriteLine( "// Generated on : " ); 
				op.WriteLine( "// " + Server.ScriptCompiler.Assemblies.Length + "," +ScriptCompiler.Assemblies.Rank); 
				for(int iTemp=0; iTemp<ScriptCompiler.Assemblies.Length; iTemp++)
				{
					foreach( Type t in ScriptCompiler.Assemblies[iTemp].GetTypes() )
					{	 
						//t = ScriptCompiler.Assemblies[iCount].GetType();
						//Type t=temp.GetType();
						Type[] ctorTypes = new Type[0]; 
						ConstructorInfo ctor = t.GetConstructor( ctorTypes ); 
						if ( ctor == null || t.IsAbstract ) continue; 
						if ( t.IsSubclassOf( typeof( Item ) ) ) 
						{ 
							Item i = (Item)ctor.Invoke( null ); 
							if ( i == null ) continue; 
							string ItemName = "None"; 
							string MainCat = "None"; 
							string SubCat = "None"; 
							ArrayList subTypes = new ArrayList(); 
							Type sub = t; 
							while ( sub.BaseType != typeof( object ) && sub.BaseType != null ) 
							{ 
								subTypes.Add( sub.BaseType.Name ); 
								sub = sub.BaseType; 
							} 

							if ( subTypes.Count >= 1 ) 
							{ 
								MainCat = subTypes[0] as string; 
							} 
                        
							if ( subTypes.Count >= 2 ) 
							{ 
								SubCat = subTypes[1] as string; 
							} 

							if ( i.Name == null ) 
							{ 
								if ( i.ItemID < TileData.ItemTable.Length ) 
									ItemName = TileData.ItemTable[i.ItemID].Name; 
							} 
							else 
							{ 
								ItemName = i.Name; 
							} 
							op.WriteLine( t.Name + "=" + MainCat + ", " + SubCat + "=" + ItemName + "=" + i.Hue + "=" + i.ItemID ); 
							iCount++;
							i.Delete(); 
						} 
					}
				}
				op.Close();
			} 
			
			e.Mobile.SendMessage( "done [ " + iCount + " items ]" ); 
			Console.WriteLine( "done [ " + iCount + " items ]" ); 

		}
		public string sLeft(string s,int length) 
		{ 
			string tmpstr = s.Substring(0, length); 
			return tmpstr; 
		} 
	} 
}

namespace Server.Mobiles
{
	public class GMTSpawner : Spawner
	{
		public GMTSpawner() : base(  )
		{
			ArrayList creaturesName = new ArrayList();
			InitSpawn( 1, TimeSpan.FromMinutes( 5 ), TimeSpan.FromMinutes( 10 ), 0, 4, creaturesName );
		}
		public GMTSpawner( Serial serial ) : base( serial )
		{
		}

		[Constructable]
		public GMTSpawner( int amount, int minDelay, int maxDelay, int team, int homeRange, string creatureName )
		{
			ArrayList creaturesName = new ArrayList();
			creaturesName.AddRange( creatureName.ToLower().Split(",".ToCharArray()));
			InitSpawn( amount, TimeSpan.FromMinutes( minDelay ), TimeSpan.FromMinutes( maxDelay ), team, homeRange, creaturesName );
			Name="GMT Spawner";
		}
		[Constructable]
		public GMTSpawner( string creatureName )
		{
			ArrayList creaturesName = new ArrayList();
			creaturesName.AddRange( creatureName.ToLower().Split(",".ToCharArray()));
			InitSpawn( 1, TimeSpan.FromMinutes( 5 ), TimeSpan.FromMinutes( 10 ), 0, 4, creaturesName );
			Name="GMT Spawner";
		}
		[Constructable]
		public GMTSpawner( int amount, TimeSpan minDelay, TimeSpan maxDelay, int team, int homeRange, ArrayList creaturesName ) : base( 0x1f13 )
		{
			InitSpawn( amount, minDelay, maxDelay, team, homeRange, creaturesName );
			Name="GMT Spawner";
		}
		public override void Serialize( GenericWriter writer )
		{
			base.Serialize(writer);
		}
		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize(reader);
		}

	}
}